function H = addright(ax,selleft)
if nargin < 1
   ax = gca;
end;
if nargin<2
   selleft=0;
end;
if selleft
   selleft='off';
else
   selleft='on';
end;
if ischar(ax)
   if strcmp(ax(1:2),'-a')
      adjustscales(gcf);
      return;
   end;
end;
hfig =  get(ax, 'parent');
leg=findobj(gcf,'tag','legend');
t=findobj(leg,'type','text');
legends=get(t,'string');
leglen=size(legends,1);
hout=get(ax,'TickDir');
series = get(ax, 'children');
fname=get(ax,'FontName');
fsize=get(ax,'FontSize');
xlab=get(get(ax,'Xlabel'),'string');
dataleft = {};
dataright = {};
hasselected=0;
for i = 1:length(series)
   if strcmp(get(series(i),'selected'),'on')
      hasselected=1;
      break;
   end;
end;
if ~hasselected &(~isempty(series))
   alist=cell(length(series),1);
   for i = length(series):-1:1
      k=length(series)+1-i;
      a=figdata(k);
      if i<leglen
         alist{i}=sprintf('series %d (%s) [%0.0f,%0.0f]',i,strtrim(legends(i,:)),min(a(:,2)),max(a(:,2)));
      else
         alist{i}=sprintf('series %d [%0.0f,%0.0f]',i,min(a(:,2)),max(a(:,2)));
      end;         
   end;
   s = listdlg('ListString',alist,...
                    'PromptString','Select series for the right axis (>=1):',...
                    'SelectionMode','multiple');
   s=length(series)-s+1;
   set(series(s),'selected','on');
end;
colorl = [];
colorr = [];
legl={};
legr={};
%dataright=cell(length(series),1);
for i = length(series):-1:1
   if strcmp(get(series(i),'selected'),selleft)
      dataright = [dataright, {figdata(i)}];
      colorr = [colorr; get(series(i), 'color')];
     if length(series)+1-i<leglen
         legr=[legr,{strtrim(legends(length(series)+1-i,:))}];
     end;
   else
      dataleft = [dataleft {figdata(i)}];
      colorl = [colorl; get(series(i), 'color')];
      if length(series)+1-i<leglen
         legl=[legl,{strtrim(legends(length(series)+1-i,:))}];
      end;
   end
end;
if ~hasselected
   set(series(s),'selected','off');
end;
axs=findobj(hfig,'tag','left axis');
h = 0;
if isempty(axs)
   if (~isempty(dataleft)) & (~isempty(dataright))
      %Plot one line against each of the left and right y-axis
      hfig=figure;
      h = 1;
      [axs, h1, h2] = plotyy(dataleft{h}(:,1),dataleft{h}(:,2),dataright{h}(:,1),dataright{h}(:,2));
      set(h1,'color',colorl(1,:));
      set(h2,'color',colorr(1,:));
      colors=get(axs,'Ycolor');
      set(axs(1),'tag','left axis');
      set(axs(2),'tag','right axis');
   end;
else
   axs(2)=findobj(hfig,'tag','right axis');
end;
%Plot additional line against the left y-axis
for i = 1 + h:length(dataleft);
  line(dataleft{i}(:,1),dataleft{i}(:,2),'Parent', axs(1), 'Color',colorl(i,:));
end;
for i = 1 + h:length(dataright);
   line(dataright{i}(:,1),dataright{i}(:,2),'Parent', axs(2), 'Color',colorr(i,:));
end;
set(axs,'TickDir',hout);
set(axs,'FontName',fname);
set(axs,'FontSize',fsize);
set(axs,'YLimMode','auto');
set(axs,'YTickMode','auto');
hlab=get(axs(1),'Xlabel');
set(hlab,'string',xlab);
set(hlab,'FontName',fname);
set(hlab,'FontSize',fsize);
if ~isempty(legl)
legh=legend(axs(1),legl,2);
set(legh,'color',[1 1 1]);
t=findobj(legh,'type','text');
set(t,'color',colors{1});
end;
if ~isempty(legr)
legh=legend(axs(2),legr,1);
set(legh,'color',[1 1 1]);
t=findobj(legh,'type','text');
set(t,'color',colors{2});
end;
adjustscales(hfig);
H=gca;

function adjustscales(hfig)
axs(1)=findobj(hfig,'tag','left axis');
axs(2)=findobj(hfig,'tag','right axis');
hout=get(axs(1),'TickDir');
fname=get(axs(1),'FontName');
fsize=get(axs(1),'FontSize');
set(axs,'TickDir',hout);
set(axs,'FontName',fname);
set(axs,'FontSize',fsize);
set(axs(2),'position',get(axs(1),'position'));
set(axs(2),'xlim',get(axs(1),'xlim'));



