%COPYFIG - Copy a figure to a new figure on screen. 
%   Note that when you copy a figure to a figure with a high number, 
%   it is not erased with the command ERA. Subsequently, the figure can
%   be combined with the command COMBFIG.
%
%   Usage:
%   COPYFIG TONR - Copy the current figure to a new figure with number TONR.
%   COPYFIG FROMNR TONR - Copy figure FROMNR to TONR.
%
%   See also COMBFIG, ERA

%   Copyright 2011 WUR
%   Revision: 1.0.7 $ $Date: 27-Oct-2011 17:17:08 $
function copyfig(from,to)
if nargin==1
   to=i_checkstr(from);
   from=gcf;
elseif nargin==2
   from=i_checkstr(from);
   to=i_checkstr(to);
else
   error('no figures specified');
end;
if ishandle(to)
   delete(to);
end;
h=figure(to);
if ishandle(from)
   ax=findobj(from,'type','axes');
   copyobj(ax, h);
else
   disp('Error in copyfig: source figure doesn''t exist');
end;

