%KE - Keep the final state
%   Fix the final state of the last simulation as new starting
%   point.
%   
%   Usage:
%   KE - saves the final state
%   KE -start (-s) - saves the start state
%   KE T - saves the state closest to time T (no interpolation is used)
%
%   
%   See also VAL, RU

%   Copyright 2011 WUR
%   Revision: 1.0.7 $ $Date: 27-Oct-2011 17:17:08 $

%   See also:
%   VAL, RU
function ke(opt)
global g_Y g_t g_grind;   
if (nargin==1)
   if strncmpi(opt,'-s',2)
      ndx=1;
   else
      opt=i_checkstr(opt);
      if ~ischar(opt)
         aa=abs(g_t-opt);
         ndx=find(aa==min(aa));
      end;
   end;
else
   ndx=size(g_Y,1);
end;
if ~isempty(g_Y)
   i_keep(g_Y(ndx, :));
   if ~isempty(g_grind.permanent)
      defpermanent('-s',defpermanent('-p',g_t(ndx))); 
   end;
else
   disp('No simulation run to keep, use TIME or RU to simulate first');
end;
