%LOADDATA - Load a data file
%   Load a data file with data of external variables or state variables (for 
%   data fitting, see OPTIMPARS). The first row of the file should contain 
%   the names of the variables (t=time). If there is no time entered, it is 
%   assumed that the data are equally spaced with time step 1. The format of the
%   ASCI file should be TAB delimited, comma delimited or space delimited.
%
%   Usage:
%   LOADDATA - The user can select a file.
%   LOADDATA FILENAME- Loads the data file FILENAME.
%
%   See also SETDATA, DEFEXTERN, OPTIMPARS

%   Copyright 2011 WUR
%   Revision: 1.0.7 $ $Date: 27-Oct-2011 17:17:08 $
function loaddata(filename)
global g_grind;
if nargin==0
   if isfield(g_grind,'loaddata')
      filter=[g_grind.loaddata.path filesep '*.csv' pathsep '*.dat' pathsep '*.txt'];
   else
      filter=['*.csv' pathsep '*.dat' pathsep '*.txt'];
   end;
   [filename,path]=uigetfile(filter, 'Get data file (delimited or CSV)');
   if filename ~= 0
      filename = [path filename];
   else
      return;
   end;
end;
if ~isempty(strfind(filename, ';'))
   filename =filename(1:strfind(filename, ';')-1);
end;
    
[varlist, amatrix] = i_loaddata(filename);
setdata(amatrix,varlist);
