%MULTASSIGNIN Assign variable in workspace.
%    MULTASSIGNIN(WS,'name',V) assigns the variable 'name' in the
%    workspace WS the value V.  WS can be one of 'caller' or 'base'. 
%    The variable 'name' may also include vector or matrix elements, e.g. 
% 
%    See also:
%    ASSIGNIN, EVALIN
%
function multassignin(ws, name, V)
if isempty(strfind(char(name),'('))
   assignin(ws, name, V);
else
   evalin(ws, sprintf('%s=%g;',name,V));
end;
