function answers = i_setdatadlg(arg, matrixstr)

if nargin == 2
   h0 = figure('Color',[0.8 0.8 0.8], ...
      	'MenuBar','none', ...
      	'Name','Set data', ...
      	'NumberTitle','off', ...
      	'PaperPosition',[18 180 576 432], ...
      	'PaperType','A4', ...
      	'PaperUnits','points', ...
      	'Position',[283  183  640  435], ...
      	'Tag','Fig1', ...
      	'ToolBar','none');
   h1 = uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[1 1 1], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[18.75 217.5 344 15], ...
      	'String',arg, ...
      	'Style','edit', ...
      'Tag','VarlistEdit');
   h1 = uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[1 1 1], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[18.75 39.75 344 153], ...
      	'String',matrixstr, ...
         'Style','edit', ...
         'Max',10, ...
      	'Tag','MatrixEdit');
   h1 = uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','i_setdatadlg(''cancel'')', ...
      	'ListboxTop',0, ...
      	'Position',[215.25 13.5 74.25 18.75], ...
      	'String','Cancel', ...
      	'Tag','Pushbutton2');
   h1 = uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','i_setdatadlg(''ok'')', ...
      	'ListboxTop',0, ...
      	'Position',[299.25 13.5 74.25 18.75], ...
      	'String','OK', ...
      	'Tag','Pushbutton2');
   h1 = uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[18.75 234 231.25 15], ...
      	'String','List of state variables and external variables', ...
   	    'Style','text', ...
      	'Tag','StaticText1');
   h1 = uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','i_setdatadlg(''load'')', ...
      	'ListboxTop',0, ...
      	'Position',[257.25 239.25 101.25 18.75], ...
      	'String','Load from file', ...
      	'Tag','AdvancedButton');
   h1 = uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[18.75 193 131.25 15], ...
      	'String','Data', ...
      	'Style','text', ...
         'Tag','StaticText1');
   uiwait(h0);
   ud = get(gcf, 'userdata');
   if ~isempty(ud) & strcmp(ud, 'ok')
      h1=findobj(gcf,'tag','VarlistEdit');
      answers{1} = get(h1, 'String');
      h1=findobj(gcf,'tag','MatrixEdit');
      answers{2} = get(h1, 'String');
   else
      answers = {};
   end;
   close;
else
   switch arg
   case 'ok'
      set(gcbf,'userdata','ok');
      uiresume;
    case 'cancel'
      set(gcbf,'userdata','cancel');
      uiresume;
    case 'load'
      [filename,path]=uigetfile('*.csv;*.dat;*.txt', 'Get data file (delimited or CSV)');
      if filename ~= 0
         filename = [path filename];
         [varlist,amatrix]=i_loaddata(filename);
         h1=findobj(gcf,'tag','MatrixEdit');
         set(h1, 'String', amatrix);
         h1=findobj(gcbf,'tag','VarlistEdit');
         set(h1, 'String', varlist);
      end;
   end;
end;





