% PASTE- Paste any matrix from clipboard
%   Paste any matrix from the Windows clipboard, which was stored 
%   as text tab delimited (for instance with Microsoft Excel). If there are text
%   strings in the clipboard a cell array is created else a matrix.
%
%   Usage:
%   A=PASTE - Paste the contents of the clipboard to the variable A (cell array or matrix).
%   A=PASTE(1) - Paste the contents of the clipboard to the variable A, force A 
%   to be a matrix, character strings are converted to NaN values.
%
%   See also CLIPBOARD

%   Copyright 2011 WUR
%   Revision: 1.0.7 $ $Date: 27-Oct-2011 17:17:09 $
function A=paste(forcematrix)
if nargin==0
   forcematrix=0;
end;
direct = cd;
cd(grindpath);
!DLMCLP.EXE 1
drawnow;
A = tabread('dlm.txt',forcematrix);
delete dlm.txt;
cd(direct);

