function [sizes1, freq1, B1] = powerlaw(A, critA)
if nargin < 2
   critA = mean(mean(A));
end;
C=A >= critA;
B = zeros(size(A));
patches = [];
ipatch = 1;
[siz1,siz2] = size(A);
for i = 1:size(A, 1)
   for j = 1:size(A, 2)
      if C(i, j)&B(i,j)==0
         B(i, j) = 1;
         ndx1 = [i,j];
         newndx=ndx1;
         while ~isempty(newndx)
            ndx = newndx;
            newndx = [];
            for k = 1:size(ndx, 1)
               n1 = ndx(k, 1)-1; n2 = ndx(k, 2);
               if (n1 > 0) & (n1 <= siz1) & (n2 > 0) & (n2 <= siz2) & C(n1, n2) & (B(n1, n2) == 0);
                  B(n1, n2) = 1;
                  newndx = [newndx; n1, n2];
               end;
               n1=n1+2;
               if (n1 > 0) & (n1 <= siz1) & (n2 > 0) & (n2 <= siz2) & C(n1, n2) & (B(n1, n2) == 0);
                  B(n1, n2) = 1;
                  newndx = [newndx; n1, n2];
               end;
               n1 = ndx(k, 1); n2 = ndx(k, 2)-1;
               if (n1 > 0) & (n1 <= siz1) & (n2 > 0) & (n2 <= siz2) & C(n1, n2) & (B(n1, n2) == 0);
                  B(n1, n2) = 1;
                  newndx = [newndx; n1, n2];
               end;
               n2=n2+2;
               if (n1 > 0) & (n1 <= siz1) & (n2 > 0) & (n2 <= siz2) & C(n1, n2) & (B(n1, n2) == 0);
                  B(n1, n2) = 1;
                  newndx = [newndx; n1, n2];
               end;
            end;
            if ~isempty(newndx)
               ndx1 = [ndx1; newndx];
            end;
         end;
         s = size(ndx1, 1);
         %       B(sub2ind(siz, ndx1(:, 1), ndx1(:, 2))) = s;
         patches(ipatch) = s;
         ipatch = ipatch + 1;
      end;
   end;
end;
patches = sort(patches);
sizes = [];
freq = [];
i = 1;
j = 1;
while i <= length(patches)
   sizes(j) = patches(i);
   freq(j) = 1;
   i = i + 1;
   while i <= length(patches) & patches(i) == sizes(j)
      i = i + 1;
      freq(j) = freq(j) + 1;
   end;
   j = j + 1;
end;
if nargout == 0
   figure(100);
   plot(sizes, freq, 'o');
   try
      i_plotdefaults;
   catch
   end;
   set(gca,'YScale','log');
   set(gca,'XScale','log');
   xlabel('size patch (cells)');
   ylabel('frequency');
else
   sizes1 = sizes;
   freq1 = freq;
   B1 = B;
end;





