function out = i_conteqdlg(flag)
if nargin == 0
   flag = 'init';
end;
global g_grind;
switch flag
case 'init'
   i_conteqdlg('Createdlg');
   if isfield(g_grind, 'continue')
      ud = g_grind.continue;
%      settings=getparsettings;
%      changed=(length(settings)~=length(ud.settings))|(sum(settings~=ud.settings)>0);
      if (length(ud.eqlist)>1)%&~changed
         set(findobj(gcf,'tag','PopupEqlist'),'string',ud.eqlist);
         set(findobj(gcf,'tag','PopupEqlist'),'value',ud.eqno);
         set(findobj(gcf,'tag','PopupEqlist'),'backgroundcolor',[1 1 1]);
      end;
      set(findobj(gcf,'tag','PopupPars'),'value',ud.ipar);
      set(findobj(gcf,'tag','EditMinimum'),'string',num2str(ud.min));
      set(findobj(gcf,'tag','EditMaximum'),'string',num2str(ud.max));
      set(findobj(gcf,'tag','EditNsteps'),'string',num2str(ud.nsteps));
   elseif isfield(g_grind,'paranal')&isfield(g_grind.paranal,'par')
      p=g_grind.paranal.par{1};
      ipar=i_getno(p);
       set(findobj(gcf,'tag','PopupPars'),'value',ipar.no);
      set(findobj(gcf,'tag','EditMinimum'),'string',num2str(g_grind.paranal.start(1)));
      set(findobj(gcf,'tag','EditMaximum'),'string',num2str(g_grind.paranal.nend(1)));
   end;
   
   uiwait;
   out = get(gcf, 'userdata');
   close(gcf);
case 'OK'
   ud.settings=getparsettings;
   ud.eqlist=get(findobj(gcbf,'tag','PopupEqlist'),'string');
   if strcmp(ud.eqlist{1},'no equilibria found')
      uiresume;
      error('There is no equilibrium to follow');
   end;
   ud.eqno=get(findobj(gcbf,'tag','PopupEqlist'),'value');
   s = ud.eqlist{ud.eqno};
   if ~strcmp(s,'All equilibria')
      N1=str2num(s(strfind(s, ':')+2:end)); %#ok
      ud.N0 = N1;
      i_keep(N1);
   else
      ud.N0=[];
   end;
   ud.ipar=get(findobj(gcbf,'tag','PopupPars'),'value');
   ud.min=str2double(get(findobj(gcbf,'tag','EditMinimum'),'string'));
   ud.max=str2double(get(findobj(gcbf,'tag','EditMaximum'),'string'));
   ud.nsteps=str2double(get(findobj(gcbf,'tag','EditNsteps'),'string'));
   set(gcbf, 'userdata',ud);
   g_grind.continue=ud;
   uiresume;
 case 'Cancel'
   ud = [];
   set(gcbf, 'userdata',ud);
   uiresume;
 case 'Help'
   commands conteq
 case 'UpdateEq'
    eqlist = findeqs('-r');
    if isempty(eqlist)
       eqlist={'no equilibria found'};
   end;
   h=findobj(gcbf,'tag','PopupEqlist');
   set(h, 'string', eqlist);
   set(h, 'BackgroundColor', [1 1 1]);
 case 'Createdlg'
   N0 = i_initvar;
   eqlist = findeqs(0);
   eqcolor  = [0.8 0.8 0.8];
   if ~isempty(eqlist)
      s=eqlist{1};
      f=findstr(s,':');
      N1=str2num(s(f+2:end))'; %#ok
     % N1=str2num(eqlist{1}(strfind(eqlist{1+2:end)), ':')'; %#ok
   else
      N1 = N0 + 2;
   end;
   if sum((N1-N0).^2) > 1E-3;
      eqlist = findeqs;
      if isempty(eqlist)
         eqlist={'no equilibria found'};
      else
         eqlist=[eqlist,{'All equilbria'}];
      end;
      eqcolor = [1 1 1];
   end;

   h0 = figure('Color',[0.8 0.8 0.8], ...
      	'MenuBar','none', ...
      	'Name','Continue equilibrium', ...
      	'NumberTitle','off', ...
      	'PaperPosition',[18 180 576 432], ...
      	'PaperUnits','points', ...
      	'Position',[554 355 460 234], ...
      	'Tag','Fig1', ...
      	'ToolBar','none');
    uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[9 150 320.25 16.5], ...
      	'String','Continu an equilibrium with respect to one parameter', ...
      	'Style','text', ...
      	'Tag','StaticText1');
    uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      'Position',[9 111 93.75 15], ...
      'String','Parameter:', ...
      	'Style','text', ...
      	'Tag','StaticText2');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[1 1 1], ...
      	'ListboxTop',0, ...
      	'Position',[129 111 149.25 15], ...
      	'String',g_grind.pars, ...
      	'Style','popupmenu', ...
      	'Tag','PopupPars', ...
      	'Value', 1);
    uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[1 1 1], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      'Position',[129 86.25 147 15], ...
      	'Style','edit', ...
      	'Tag','EditMinimum');
    uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[1 1 1], ...
      	'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      	'Position',[129 63 146.25 15], ...
      	'Style','edit', ...
      	'Tag','EditMaximum');
    uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[1 1 1], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[129 39.75 147 15], ...
      	'String','300', ...
      	'Style','edit', ...
      	'Tag','EditNsteps');
    uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[9 88.125 75 15], ...
      	'String','Minimum', ...
      	'Style','text', ...
      	'Tag','StaticText3');
    uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[9 65.4375 90.75 15], ...
      	'String','Maximum', ...
      	'Style','text', ...
      	'Tag','StaticText3');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[9 42.75 102 15], ...
      	'String','Number of steps', ...
      	'Style','text', ...
      	'Tag','StaticText3');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[9 133.5 97.5 15], ...
      	'String','Equilibrium:', ...
      	'Style','text', ...
      	'Tag','StaticText3');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',eqcolor, ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[129 133.5 149.25 15], ...
      	'String',eqlist, ...
      	'Style','popupmenu', ...
      	'Tag','PopupEqlist', ...
      	'Value', 1);
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','i_conteqdlg(''OK'')', ...
      	'ListboxTop',0, ...
      	'Position',[41.25 9.75 71.25 18], ...
      	'String','OK', ...
      	'Tag','Pushbutton1');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'Callback','i_conteqdlg(''UpdateEq'')', ...
      	'ListboxTop',0, ...
      	'Position',[285 133.5 18.75 13.5], ...
      	'String','...', ...
   	'Tag','Pushbutton3', ...
      	'TooltipString','Update list');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','i_conteqdlg(''Cancel'')', ...
      	'ListboxTop',0, ...
      	'Position',[127.875 9.75 71.25 18], ...
      	'String','Cancel', ...
      	'Tag','Pushbutton1');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','i_conteqdlg(''Help'')', ...
      	'ListboxTop',0, ...
      	'Position',[213.75 9.75 71.25 18], ...
      	'String','Help', ...
      	'Tag','Pushbutton1');
   
end;

function settings=getparsettings
global g_grind;
if g_grind.statevars.vector
   maxn=500;
else
   maxn=length(g_grind.pars)+1;
end;   
settings=zeros(1,maxn);
j = 0;
for i = 1:length(g_grind.pars)
   p = evalin('base', char(g_grind.pars{i}));
   jj=numel(p);
   j2=j+jj;
   while j2 + 1 > maxn
      addn=j2 + 1;
      maxn = maxn + addn;
      settings = [settings, zeros(1,addn)];
   end;
   settings(j+1:j2)=p(1:jj);
   j=j2;
end;
settings=settings(1:j);
