function fig = i_outdlg(flag, flag2)
global g_grind;
if nargin == 0
   flag = 'init';
end;
switch flag
case 'init'
   if nargin <2
      if ~isempty(g_grind)&isfield(g_grind,'outdlg')
         flag2=g_grind.outdlg;
      else
         flag2=1;
      end;
   end;
   plotlst = {};
   if ~isempty(g_grind)
       N=length(g_grind.timevars);
       while (N>0)&isempty(g_grind.timevars{N})
          N=N-1;
       end;
    end;
    if N<1
       N=1;
    end;
    if flag2>N
       N=flag2;
    end;
    for i = 1:N
      plotlst{i} = sprintf('Time Plot %d', i);
   end;
   h0 = figure('Units','points', ...
	'Color',[0.8 0.8 0.8], ...
	'MenuBar','none', ...
	'Name','Edit Time Plots', ...
	'NumberTitle','off', ...
	'PaperPosition',[18 180 576 432], ...
	'PaperType','A4', ...
	'PaperUnits','points', ...
	'Position',[296.25 270.75 366 234], ...
	'Tag','outdlg', ...
	'ToolBar','none');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[17.25 126.75 303.75 15], ...
	'String','Y-axis: list of variables/functions, delimited with spaces', ...
	'Style','text', ...
	'Tag','StaticText2');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Max',30, ...
	'Position',[17.25 38.25 318.75 91.5], ...
   'Style','edit', ...   
   'TooltipString','Enter here a list of variables or functions for the Y-axis',...
	'Tag','EditList');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[17.25 197.25 72.75 15], ...
	'String','Time Plot No.', ...
	'Style','text', ...
   'Tag','StaticText1');
hplotno = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'Callback','i_outdlg(''changeplot'')', ...
	'ListboxTop',0, ...
	'Position',[81 195 113.25 22.5], ...
	'String',plotlst, ...
	'Style','popupmenu', ...
	'Tag','PlotNo', ...
   'TooltipString','Select Time Plot here',...
	'Value',flag2);
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'Callback','i_outdlg(''newplot'')', ...
	'ListboxTop',0, ...
	'Position',[243 196.5 93.75 22.5], ...
	'String','Add Time Plot', ...
   'TooltipString','Add new plot to the list of time plots',...
	'Tag','AddBtn');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'Callback','i_outdlg(''ok'')', ...
	'ListboxTop',0, ...
	'Position',[31.5 8.25 93.75 22.5], ...
	'String','OK', ...
   'TooltipString','Close and save',...
	'Tag','OKBtn');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'Callback','i_outdlg(''cancel'')', ...
	'ListboxTop',0, ...
	'Position',[141 8.25 93.75 22.5], ...
	'String','Cancel', ...
   'TooltipString','Close and undo changes',...
	'Tag','CancelBtn');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'Callback','commands outdlg', ...
	'ListboxTop',0, ...
	'Position',[250.5 8.25 93.75 22.5], ...
	'String','Help', ...
   'TooltipString','Open help window',...
	'Tag','HelpBtn');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[17.25 165 303.75 15], ...
	'String','X-axis: one variable/function', ...
	'Style','text', ...
	'Tag','StaticText2');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[17.25 153 318 16.5], ...
	'String','t', ...
	'Style','edit', ...
    'TooltipString','Edit the variable for the time axis here',...
  'Tag','EditTime');
   if N==1
     set(hplotno,'Enable','off');
   end;
%    global g_grind; 
    if ~isempty(g_grind)
       ud.oudlist=g_grind.timevars;
       ud.oudoutt=g_grind.outt;
    else
       ud.oudlist={};
       ud.oudoutt={};
    end;
    ud.curr=flag2;
    set(h0,'userdata',ud);
   setplot(ud.curr,h0);
   if nargout > 0, fig = h0; end
 case 'ok'
%    global g_grind;
    ud=get(gcbf,'userdata');
    savecurrent(ud.curr);
    g_grind.outdlg=ud.curr;
    delete(gcbf);
    disp(' ');
   out('?');
 case 'cancel'
    ud=get(gcbf,'userdata');
%    global g_grind;
    g_grind.timevars=ud.oudlist;
    g_grind.outt=ud.oudoutt;
    g_grind.outdlg=ud.curr;
   delete(gcbf);
    disp(' ');
    out('?');
 case 'newplot'
   h=findobj(gcbf,'Tag','PlotNo');
   plotlst = get(h,'string');
   No=length(plotlst)+1;
   plotlst{No} = sprintf('Time Plot %d', No);
   if No>1
     set(h,'Enable','on');
   end;
   set(h,'string',plotlst);
   set(h,'value',No);
   i_outdlg('changeplot');
case 'changeplot'
    ud=get(gcbf,'userdata');
    savecurrent(ud.curr);
    h=findobj(gcbf,'tag','PlotNo');
  v=get(h,'Value');
  setplot(v,gcbf);
  ud.curr=v;
  set(gcbf,'userdata',ud);
end;

function savecurrent(No)
    h=findobj(gcbf,'Tag','EditList');
    lst=get(h,'String');
    if ~isempty(lst)
       eval(sprintf('out -silent -%d %s', No, lst));
    else
       eval(sprintf('out -silent -%d -clear',No));
    end;
    h=findobj(gcbf,'tag','EditTime');
    tim=strtrim(get(h,'string'));
    if isempty(tim)
       tim='t';
    end;
    global g_grind
    g_grind.outt{No}=tim;

function setplot(No,f)
global g_grind;
if isempty(g_grind)|(No>length(g_grind.timevars))
   s='';
   tim='t';
else
   vars = g_grind.timevars{No};
      for i = 1:length(vars)
         if ~isempty(strfind(vars{i}, ' '))
            vars{i}=['''' vars{i} ''''];
         end;
      end;
      s = sprintf('%s ', vars{:});
    tim=g_grind.outt{No};
end;
h=findobj(f,'tag','EditList');
set(h,'string',s);
h=findobj(f,'tag','EditTime');
set(h,'string',tim);
