function res = i_outfundlg(flag, def)
if nargin == 0
   flag = 'init';
end;
switch flag
 case 'init'
   if nargin < 2
      def.fun = '';
      def.opt = 1;
   end;
   h0 = figure('Units','points', ...
      'Color',[0.8 0.8 0.8], ...
      'MenuBar','none', ...
      'Name','Enter function and source for outfun', ...
      'NumberTitle','off', ...
      'PaperPosition',[18 180 576 432], ...
      'PaperUnits','points', ...
      'Position',[357 384.75 309 142.5], ...
      'Tag','outfun', ...
      'ToolBar','none');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[21 117 264 9], ...
      'String','Enter function, state variable, auxiliary variable etc.:', ...
      'Style','text', ...
      'Tag','StaticText1');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[21 65.25 122.25 15.75], ...
      'String','Source of data:', ...
      'Style','text', ...
      'Tag','StaticText2');
   hedit = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[1 1 1], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'String',def.fun, ...
      'Position',[21 99 261 15], ...
      'Style','edit', ...
      'Tag','EditText1');
   hopt = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[1 1 1], ...
      'ListboxTop',0, ...
      'Position',[21 52.5 261 15], ...
      'String',{'normal run','paranal','paranal2d','conteq','mcarlo'},... %,'conteq2d'}, ...
      'Style','popupmenu', ...
      'Tag','PopupMenu1', ...
      'Value', def.opt);
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'Callback','i_outfundlg(''ok'')',...
      'ListboxTop',0, ...
      'Position',[216 15.75 63 17.25], ...
      'String','OK', ...
      'Tag','Pushbutton1');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'Callback','i_outfundlg(''cancel'')',...
      'ListboxTop',0, ...
      'Position',[22.5 14.25 63 17.25], ...
      'String','Cancel', ...
      'Tag','Pushbutton1');
   uiwait(h0);
   res = [];
   if ishandle(h0)
      ud = get(h0, 'userdata');
      if ud
         res.fun = get(hedit, 'string');
         res.opt = get(hopt, 'value');
         res.optstr = get(hopt, 'string');
         res.optstr = res.optstr{res.opt};
      end;
      close(h0);
   end;
 case 'cancel'
   set(gcbf, 'userdata', 0);
   uiresume;
 case 'ok'
   set(gcbf, 'userdata', 1);
   uiresume;
end;

