function selndx = i_parseldlg(tag, pars, Li, perc, critvals)
if nargin == 0
   tag = 'init';
end;
switch tag
case 'init'
   [Li1,ndx] = sort(Li); 
   ud.pars=pars;
   sortedpars={pars{ndx}};
   f=find(perc>0.5);
   perc=perc(f);
   ud.Li=Li;
   ud.critvals=[-9999;critvals(f)'];
   ps={'all'};
   for i=1:length(perc)
       ps=[ps {sprintf('p<%g',1-perc(i))}];
   end;
   h0 = figure('Units','points', ...
      'MenuBar','none', ...
      'Name','Select parameters for dendrogram', ...
      'NumberTitle','off', ...
      'Color',[0.8 0.8 0.8], ...
      'PaperPosition',[18 180 576 432], ...
      'PaperUnits','points', ...
      'Position',[194.25 159.75 420 315], ...
      'Tag','parseldlg', ...
      'ToolBar','none');
   set(h0,'userdata',ud);
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[1 1 1], ...
      'Position',[276.75 52.5 120.75 233.25], ...
      'String',sortedpars, ...
      'Style','listbox', ...
      'Tag','SelList', ...
      'Value', 1);
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[38.25 287.25 150 15], ...
      'String','Removed parameters', ...
      'Style','text', ...
      'Tag','StaticText1');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[1 1 1], ...
      'Position',[36 51 120.75 233.25], ...
      'String',' ', ...
      'Style','listbox', ...
      'Tag','UnselList', ...
      'Value', 1);
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[279 287.25 150 15], ...
      'String','Parameters for dendrogram', ...
      'Style','text', ...
      'Tag','StaticText1');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[188.25 230.25 70.5 15], ...
      'String','Select', ...
      'Style','text', ...
      'Tag','StaticText2');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'Callback','i_parseldlg(''select'')', ...
      'ListboxTop',0, ...
      'Position',[187.5 169.5 59.25 22.5], ...
      'String','Select >>', ...
      'Tag','UnselectBtn');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'Callback','i_parseldlg(''unselect'')', ...
      'ListboxTop',0, ...
      'Position',[188.25 137.25 55.5 22.5], ...
      'String','<< Remove', ...
      'Tag','SelectBtn');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'Callback','i_parseldlg(''signif'')', ...
      'ListboxTop',0, ...
      'Position',[188.25 215.25 64.5 13.5], ...
      'String',ps, ...
      'Style','popupmenu', ...
      'Tag','SignifPopup', ...
      'Value', 1);
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'Callback','i_parseldlg(''OK'')', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'ListboxTop',0, ...
      'Position',[331.5 13.5 64.5 22.5], ...
      'String','OK', ...
      'Tag','Pushbutton3');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'Callback','i_parseldlg(''Help'')', ...
      'ListboxTop',0, ...
      'Position',[249.75 13.5 64.5 22.5], ...
      'String','Help', ...
      'Tag','Pushbutton3');
   uiwait(h0);
   h = findobj(gcf, 'tag','SelList');
   selpars=get(h,'string');
   selndx=[];
   k=1;
   for j=1:length(selpars)
      for i=1:length(ud.pars)
         if strcmp(ud.pars{i},selpars{j})
            selndx(k)=i;
            k=k+1;
         end;
      end;
   end;
   selndx=sort(selndx);
   close;
case 'signif'
   h = findobj(gcbf, 'tag','SignifPopup');
   val=get(h, 'value');
   par1={};
   par2={};
   Li1=[];
   Li2=[];
   ud=get(gcbf,'userdata');
   for i=1:length(ud.pars);
      if ud.critvals(val)>ud.Li(i);
         par1=[par1 {ud.pars{i}}];
         Li1=[Li1 (ud.Li(i))];
      else
         par2=[par2 {ud.pars{i}}];
         Li2=[Li2 (ud.Li(i))];
      end;
   end;
   h = findobj(gcbf, 'tag','UnselList');
   [L,ndx] = sort(Li1); 
   set(h,'value',1);
   set(h,'string',par1(ndx));
   h = findobj(gcbf, 'tag','SelList');
   [L,ndx] = sort(Li2); 
   set(h,'value',1);
   set(h,'string',par2(ndx));
 case 'OK'
   uiresume;
 case 'Help'
   disp('help not yet implemented');
 case 'select'
   movefrom('UnselList','SelList');
 case 'unselect'
   movefrom('SelList','UnselList');
end;

function movefrom(listfrom, listto)
h = findobj(gcbf, 'tag',listfrom);
pars = get(h, 'string');
if ~isempty(pars)
   ipar = get(h, 'value');
   apar = pars{ipar};
   pars = {pars{1:ipar - 1} pars{ipar + 1:end}};
   if (ipar > length(pars)) & ~isempty(pars)
      set(h, 'value', length(pars));
   end;
   set(h, 'string',pars);
   h = findobj(gcbf, 'tag',listto);
   pars = get(h, 'string');
   if ischar(pars)
      pars = {apar};
   else
      pars = {pars{:} apar}; 
      %do not change this to [pars {apar}] as that does not work
   end;
   set(h, 'string',pars);
end;
