function i_sensplot(tag, data,parsets,vlabels,plabels)
if nargin == 0
   tag = 'init';
end;
switch tag
 case 'init'
   ud.output = data;
   ud.parsets = parsets;
   if exist('i_figno','file')
      n = i_figno('mcarlo') + 1;
   else
      n = 2;
   end;
   if ishandle(n)
      close(n);
   end;
   h0 = figure(n);
   set(h0,'Color',[0.8 0.8 0.8], ...
      'PaperPosition',[18 180 576 432], ...
      'PaperUnits','points', ...
      'Position',[269 251 560 420], ...
      'ResizeFcn','doresize(gcbf)', ...
      'Tag','Fig448', ...
      'ToolBar','figure', ...
      'DefaultaxesCreateFcn','plotedit(gcbf,''promoteoverlay''); ');
   set(h0, 'userdata', ud);
   h1 = uimenu('Parent',h0, ...
      'HandleVisibility','off', ...
      'Tag','ScribeHGBinObject', ...
      'Visible','off');
   h1 = uimenu('Parent',h0, ...
      'HandleVisibility','off', ...
      'Tag','ScribeFigObjStorage', ...
      'Visible','off');
   h1 = uimenu('Parent',h0, ...
      'HandleVisibility','off', ...
      'Tag','ScribeHGBinObject', ...
      'Visible','off');
   h1 = axes('Parent',h0, ...
      'Box','on', ...
      'CameraUpVector',[0 1 0], ...
      'Color',[1 1 1], ...
      'CreateFcn','', ...
      'Position',[0.1536 0.1762 0.7732 0.7024], ...
      'Tag','Axes1', ...
      'XColor',[0 0 0], ...
      'YColor',[0 0 0], ...
      'ZColor', [0 0 0]);
   h = line('Parent',h1, ...
      'Color',[0 0 1], ...
      'LineStyle','none', ...
      'Marker','.', ...
      'Tag','Axes1Line1', ...
      'XData',[], ...
      'YData', []);
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'ListboxTop',0, ...
      'Callback','i_sensplot(''update'')', ...
      'Position',[101.25 9 99.75 15], ...
      'String',vlabels, ...
      'Style','popupmenu', ...
      'Tag','VarPopup', ...
      'Value', 1);
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'ListboxTop',0, ...
      'Callback','i_sensplot(''update'')', ...
      'Position',[295.5 9 100.5 15], ...
      'String',plabels, ...
      'Style','popupmenu', ...
      'Tag','ParPopup', ...
      'Value', 1);
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'ListboxTop',0, ...
      'Position',[239.25 6.75 45 15], ...
      'String','X-axis', ...
      'Style','text', ...
      'Tag','StaticText1');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'ListboxTop',0, ...
      'Position',[47.25 8.25 45 15], ...
      'String','Y-axis', ...
      'Style','text', ...
      'Tag','StaticText1');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'ListboxTop',0, ...
      'Position',[100.75 280 200 15], ...
      'String',' ', ...
      'Style','text', ...
      'Tag','TitleText');
   yy =  ud.output(:, 1);
   xx = ud.parsets(:, 1);
   set(h, 'XData', xx);
   set(h, 'YData', yy);
   xlabel(plabels{1});
   ylabel(vlabels{1})
   xrange = [min(xx) max(xx)];
   xlim(xrange);
   ylim([min(yy) max(yy)]);
   Sx = sum(xx);
   regress = [sum(xx.^2) Sx; Sx length(xx)] \ [sum(xx .* yy); sum(yy)]; %linear regression (conform Grasman)
   yrange = xrange' .* regress(1) + regress(2);
   h1 = line(xrange, yrange);
   set(h1, 'color', [1 0 0]);
   set(h1,'tag','line');
 case 'update'
   ud = get(gcbf, 'userdata');
   h=findobj(gcbf,'Tag','ParPopup');
   ipar = get(h, 'Value');
   pars = get(h, 'string');
   xlabel(pars{ipar});
   h=findobj(gcbf,'Tag','VarPopup');
   ivar = get(h, 'Value');
   vars = get(h, 'string');
   ylabel(vars{ivar});
   h=findobj(gcbf,'Tag','Axes1Line1');
   yy =  ud.output(:, ivar);
   xx = ud.parsets(:, ipar);
   set(h, 'XData', xx);
   set(h, 'YData', yy);
   xrange = [min(xx) max(xx)];
   xlim(xrange);
   yrange = [min(yy) max(yy)];
   if yrange(2) - yrange(1) > 0
      ylim(yrange);
      Sx = sum(xx);
      regress = [sum(xx.^2) Sx; Sx length(xx)] \ [sum(xx .* yy); sum(yy)]; %linear regression (conform Grasman)
      yregr = xrange' .* regress(1) + regress(2);
      if yrange(2) - yrange(1) == 0
         sens = NaN; %delen door nul geeft nu NaN (anders zou het extreem gevoelig worden)
      else
         sens = regress(1) * (xrange(2) - xrange(1)) / (yrange(2) - yrange(1));
      end;
      h=findobj(gcbf,'Tag','line');
      set(h, 'XData', xrange);
      set(h, 'YData', yregr);
   else
      sens = NaN;
   end;
   h=findobj(gcbf,'Tag','TitleText');
   set(h,'string',sprintf('Sensitivity "%s" for "%s" is %g',vars{ivar},trimchar(pars{ipar},' '),sens));
end

