function fig = i_viewcellsdlg(flag, flag2)
global g_grind;
if nargin == 0
   flag = 'init';
end;
switch flag
 case 'init'
   if ~isempty(g_grind) & ~isfield(g_grind, 'viewcells')
      viewcells('-defaults');
   end;
   plotlst = {};
   if ~isempty(g_grind)
      N = length(g_grind.viewcells.vars);
      while (N > 0) & isempty(g_grind.viewcells.vars{N})
         N = N - 1;
      end;
   end;
   if N < 1
      N = 1;
   end;
   for i = 1:N
      plotlst{i} = sprintf('Plot No. %d', i);
   end;
   h0 = figure('Units','points', ...
      	'Color',[0.8 0.8 0.8], ...
      	'MenuBar','none', ...
      	'Name','Plots for Viewcells', ...
      	'NumberTitle','off', ...
      	'PaperPosition',[18 180 576 432], ...
      	'PaperType','A4', ...
      	'PaperUnits','points', ...
      	'Position',[199 232 366 205], ...
      	'Tag','viewcellsdlg', ...
      	'ToolBar','none');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[17.25 138.75 - 40 303.75 15], ...
      	'String','Size of variable', ...
      	'Style','text', ...
      	'Tag','StaticText2');
  uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[1 1 1], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Max',30, ...
      	'Position',[17 126 - 40 317 17], ...
      	'Style','edit', ...
      	'Tag','EditSize', ...
      	'TooltipString','Enter here the size of the variable');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[17 206 - 40 72.75 15], ...
      	'String','Viewcells plot No.', ...
      	'Style','text', ...
      	'Tag','StaticText1');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[1 1 1], ...
      	'Callback','i_viewcellsdlg(''changeplot'')', ...
      	'ListboxTop',0, ...
      	'Position',[105 205.5 - 40 113.25 22.5], ...
      	'String',plotlst, ...
      	'Style','popupmenu', ...
      	'Tag','PlotNo', ...
      	'TooltipString','Select Plot number here', ...
      	'Value', 1);
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','i_viewcellsdlg(''newplot'')', ...
      	'ListboxTop',0, ...
      	'Position',[243 205.5 - 40 93.75 22.5], ...
      	'String','Add Viewcells Plot', ...
      	'Tag','AddBtn', ...
      	'TooltipString','Add new plot to the list of viewcells');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','i_viewcellsdlg(''ok'')', ...
      	'ListboxTop',0, ...
      	'Position',[31.5 8.25 93.75 22.5], ...
      	'String','OK', ...
      	'Tag','OKBtn', ...
      	'TooltipString','Close and save');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','i_viewcellsdlg(''cancel'')', ...
      	'ListboxTop',0, ...
      	'Position',[141 8.25 93.75 22.5], ...
      	'String','Cancel', ...
      	'Tag','CancelBtn', ...
      	'TooltipString','Close and undo changes');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'Callback','commands viewcells', ...
      	'ListboxTop',0, ...
      	'Position',[250.5 8.25 93.75 22.5], ...
      	'String','Help', ...
      	'Tag','HelpBtn', ...
      	'TooltipString','Open help window');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[0.8 0.8 0.8], ...
      	'HorizontalAlignment','left', ...
      	'ListboxTop',0, ...
      	'Position',[17 180 - 40 303.75 15], ...
      	'String','Auxliiary or state variable', ...
      	'Style','text', ...
      	'Tag','StaticText2');
   uicontrol('Parent',h0, ...
      	'Units','points', ...
      	'BackgroundColor',[1 1 1], ...
      	'HorizontalAlignment','left', ...
      	'Callback','i_viewcellsdlg(''xchanged'')', ...
      	'ListboxTop',0, ...
      	'Position',[17 168 - 40 318 16.5], ...
      	'Style','edit', ...
      	'Tag','EditX', ...
      	'TooltipString','Edit the variable for the plot here');
   %if N==1
   %   set(hplotno,'Enable','off');
   % end;
   %    global g_grind;
   if ~isempty(g_grind)
      ud.oudlist = g_grind.viewcells;
   else
      ud.oudlist = {};
   end;
   ud.curr = g_grind.viewcells.currno;
   set(h0, 'userdata', ud);
   setplot(ud.curr, h0);
   if nargout > 0, fig = h0; end
 case 'ok'
   %    global g_grind;
   ud = get(gcbf, 'userdata');
   savecurrent(ud.curr);
   delete(gcbf);
   disp(' ');
   viewcells('-list');
   viewcells;
 case 'cancel'
   ud = get(gcbf, 'userdata');
   %    global g_grind;
   g_grind.viewcells = ud.oudlist;
   delete(gcbf);
   disp(' ');
   viewcells('-list');
 case 'newplot'
   h=findobj(gcbf,'Tag','PlotNo');
   plotlst = get(h, 'string');
   No = length(plotlst) + 1;
   plotlst{No} = sprintf('Plot No. %d', No);
   if No > 1
      set(h,'Enable','on');
   end;
   set(h, 'string', plotlst);
   set(h, 'value', No);
   i_viewcellsdlg('changeplot');
 case 'xchanged'
   h=findobj(gcbf,'tag','EditX');
   nam = get(h, 'string');
   iX = i_getno(nam);
   d = [];
   if iX.isvar
      d = g_grind.statevars.dims{iX.vecno};
   elseif iX.isfun
      d = g_grind.funcnames.dims{iX.vecno};
   end;
   if ~isempty(d)
      h=findobj(gcbf,'tag','EditSize');
      set(h,'string',sprintf('[%d %d]',[d.dim1,d.dim2]));
   end;
 case 'changeplot'
   ud = get(gcbf, 'userdata');
   savecurrent(ud.curr);
   h=findobj(gcbf,'tag','PlotNo');
   v = get(h, 'Value');
   setplot(v, gcbf);
   ud.curr = v;
   set(gcbf, 'userdata', ud);
end;

function savecurrent(No)
global g_grind;
f = gcbf;
h=findobj(f,'tag','EditX');
g_grind.viewcells.vars{No}.name = get(h, 'string');
h=findobj(f,'tag','EditSize');
g_grind.viewcells.vars{No}.dims = str2num(get(h, 'string'));
g_grind.viewcells.currno = No;

function setplot(No, f)
global g_grind;
if isempty(g_grind) | (No > length(g_grind.viewcells.vars))
   x = '';
   siz = [1 1];
else
   x = g_grind.viewcells.vars{No}.name;
   siz = g_grind.viewcells.vars{No}.dims;
end;
h=findobj(f,'tag','EditX');
set(h, 'string', x);
h=findobj(f,'tag','EditSize');
set(h,'string',sprintf('[%d %d]',siz));
h=findobj(f,'tag', 'PlotNo');
set(h, 'value', No);

