function uncertain
global g_t g_grind g_Y g_mcarlo;
i_parcheck;
if isempty(g_mcarlo)
   mcarlo;
end;
for j=1:g_grind.statevars.dim
   Percents=i_makepercentiles(g_uncertain(:,:,j),[0.05, 0.25, 0.5, 0.75, 0.95]);
   H = i_makefig('uncertain',j);
   set(H,'Name',['Uncertainty ' g_grind.statevars.names{j}]);
   title(['Uncertainty ' g_grind.statevars.names{j}]);
   plot(g_t,Percents(:,1),':');
   hold on;
   plot(g_t,Percents(:,2),'-');
   plot(g_t,Percents(:,3),'-','LineWidth',2);
   plot(g_t,Percents(:,4),'-');
   plot(g_t,Percents(:,5),':');
   ylabel(i_disptext(g_grind.statevars.names{j}));
   xlabel('Time (t)');
   legend('0.05 percentile','0.25 percentile','0.5 percentile','0.75 percentile','0.95 percentile');
   hold off;
end;
catch
   err=lasterror;
   g_grind.tstep=oldtstep;
   for i = 1:size(pars, 2)
      multassignin('base', char(pars{i}),means{i}); 
   end;
   rethrow(err);
end;


function multassignin(ws, name, V)
%multassignin supports assignments to elements of arrays (e.g. name='A(1,2)')
%fbrack should be strfind(name,'(') (added for efficiency)
fbrack = strfind(char(name), '(');
if isempty(fbrack)
   assignin(ws, name, V);
else
   temp = evalin(ws, name(1, fbrack(1) - 1));
   s = ['temp' name(fbrack(1):length(name)) ' = ' num2str(V) ';' ];
   eval(s);
   assignin(ws, name(1, fbrack(1) - 1), temp);
end;
